:userdoc.
:title.IMAPD documentation
:docprof toc=123.

.***********************************
.*   INTRODUCTION
.***********************************

:h1 res=1001 id=1001 global.Introduction

:hp2.WEASEL IMAPD PLUGIN:ehp2.

:p.:hp3.Version 0.08:ehp3.

:p.This is an Imapd server designed to run in conjunction with the
Weasel Pro mail server.
The long-term plan is that it should be a fully-integrated part of
Weasel Pro, but for now, for ease of development and testing, it
exists as a separate executable.

:p.The present version is a time-limited test/demonstration that will
expire on 30 June 2005. Thus, it is temporarily possible to use
it even if you are do not have a valid Weasel Pro registration.
After the expiry date it will continue to work for registered users
but will stop working for everyone else. However even registered
users should upgrade by then, because this is an early
test release.

:p.Although this is still officially a test version, it is starting
to look as if all the known bugs have been fixed. Thus, this is very
close to being a production version, and some people are successfully
using it as a production version.

:p.
The author of this software is Peter Moylan, peter@ee.newcastle.edu.au.
Other software by the same author may be found at
http&colon.&slash.&slash.eepjm.newcastle.edu.au.

.***********************************
.*   INSTALLATION
.***********************************

:h1 id=installation.Installation

:p.:hp2.INSTALLATION:ehp2.

:p.To install this, simply put imapd.exe into the same directory
as Weasel. Alternatively, put it into its own directory, but
put a copy of Weasel.INI into that directory so that imapd.exe
can find the Weasel mail root and the users' passwords. You
enable IMAP operation by running imapd.exe at the same time
that weasel.exe is running. Note that you will also have to run
the Weasel Setup program to define which users are allowed to
use IMAP.

:p.Suggestion: use the Weasel Setup program to create a new test
user account, so that you don't have to let imapd touch mail
for your "real" accounts. If you want complete isolation of
the test environment from your real e-mail server, run a
second copy of Weasel on a nonstandard SMTP port.

.***********************************
.*   DEINSTALLATION
.***********************************

:h1 id=deinstallation.Deinstallation

:p.:hp2.DEINSTALLATION:ehp2.

:p.To remove this software from your computer, delete the following
files from the installation directory or the indicated subdirectories.

:ul compact.
:li.imapd.exe
:li.README.IMAPD
:li.file_id.diz
:li.IMAP.INI
:li.IMAP4.LOG
:li.imapd.inf
:li.doc\imapd.ipf
:li.doc\changes.doc
:eul.

:p.In addition, various mail directories will contain files called
'boxlist' and 'itemlist', and all of these can be deleted. The various
mail folders can also be deleted, unless they contain information
that you want to keep.

:p.If you still have a zip file imapdnnn.zip, that too can be deleted.

.***********************************
.*   WHAT IS IMAP?
.***********************************

:h1 id=whatisimap.What is IMAP?

:p.:hp2.What is IMAP?:ehp2.

:p.There are three common protocols used for transporting e-mail:

:dl break=all.
:dt.   SMTP
:dd.the basic transport mechanism used for essentially
all transfers between mail servers. Normally you
also use SMTP to send all your outgoing mail.

:dt.   POP3
:dd.the most common method used by mail clients to fetch
incoming mail from the server. (There is also a
POP2, but it is obsolete.) POP3 remains popular
because it is simple and has low overhead.

:dt.   IMAP
:dd.a newer protocol that some mail clients can use
instead of POP3 to read and manipulate the mail
that is on the server. The version that this
package supports is known as IMAP4rev1.
:edl.

:p.IMAP is a lot more complicated than POP3 (so you might not want
it, because of the higher overheads). The essential difference
is that POP3 is designed for the case where the user downloads
all mail from the server and then processes it locally. (It
is possible for a POP3 user to leave a copy of the mail on the
server, but for various reasons that is not a good idea.)
With IMAP, the assumption is that the user is going to leave
the mail on the server. IMAP therefore has commands for
creating new mail folders on the server and for moving mail
between folders; commands for searching through mail without
downloading it; commands for downloading attachments without
downloading an entire message; status flags for keeping track
of things like which mail has already been read; and so on.

:p.The end result is that IMAP is attractive for the sort of user
who wants to access e-mail from several different locations.
This is possible because the user's mail store is on the server
rather than on the user's computer(s).

:p.A corollary of this is that IMAP is actually less attractive
from the viewpoint of the person running the server. You need
a more powerful server machine than with POP3, because most of
the workload has been transferred from the user's computer to
the server. In particular:

:ul.
:li.
The IMAP4 protocol is fairly complex, with many options, so
the server has to work harder to parse and respond to
commands.
:li.
While a typical POP3 session lasts only a few minutes
(download mail, delete mail, log off), an IMAP4 user is
more likely to remain logged on for days at a time. In
addition, some IMAP4 clients (e.g. Mozilla) are "greedy"
in that they open many parallel sessions for a single user,
and remain logged on in all of them until the user goes
off-line or closes all browser windows.
:li.
Keeping all past mail on the server can add up to a lot of
disk space. You might have to allow for several hundred
megabytes per user of storage space.
:eul.

:p.On the other hand, the big attraction of IMAP4 is that it makes
your service look more attractive to potential clients.


.***********************************
.*   IMPLEMENTATION STATUS
.***********************************

:h1 id=impstatus.Implementation status

:p.:hp2.Implementation status:ehp2.

:p.The following pages are supposed to show what is and isn't working.
The basic situation is that almost all of the IMAP4 protocol is
implemented, but testing is at such an early stage that I don't yet even
have a clear classification of what is present and what isn't.

:h2.Known faults
:p.:hp2.KNOWN FAULTS:ehp2.

:ul.
:li.The "known faults" list is not up to date.  &colon.)

:li.This version has been observed to crash in some situations,
and I have not yet found the cause(s) of the crash. (Fixed?)

:li.Pine doesn't like the way this server reports the BODYSTRUCTURE
of a multipart message, or the ENVELOPE of any message.
(Partially fixed.)

:li.The present implementation is based on RFC2060, rather than on the
updated RFC3501. The differences are small, but I still need
to go through the newer RFC.

:li.For the FETCH option BODY[section]<partial>, the <partial> option
is implemented but untested.

:li.There is no interlocking between POP3 and IMAP4 users, so that it
possible for POP3 and IMAP4 users to access the same mailbox
simultaneously. I have not yet decided whether this is a bug or
a feature.

:li.The parent/child relationships in nested mailbox folders was not
being updated correctly when I merged data structures in module
Boxes. Possible dangling pointers. New algorithm needed here.
(Fixed, and the fix appears to be working.)

:li.In CRAM-MD5 authentication, sometimes we hang in 100% CPU
utilisation condition. I haven't yet worked out whether this is the
fault of my software or of Mozilla. (Not observed recently, so
probably fixed.)

:eul.

:h2.Bug reports to be checked

:p.:hp2.Bug reports to be checked:ehp2.

:p.A message loses its status if I move it from inbox to another folder.
If it was read and I move to an archive folder it is displayed as new
unread message in this folder. I think this is not the correct
behaviour. I use this process very often with some other eMail accounts
and the message all stay in the same status. (Fixed now?)

:p..............


:h2.Implementation status of the various commands

:p.:hp2.IMPLEMENTATION STATUS OF THE VARIOUS COMMANDS:ehp2.

:p.The following subsections are my notes on what is working, what is
partly working, etc. So far I haven't even completed my first pass through
this, so most commands are still unclassified. Almost everything is
in fact implemented, but there's still a lot of checking to do.

:h3.Fully implemented, tested and working

:xmp.
       AUTHENTICATE (command) .....................................   27
       CAPABILITY (command) .......................................   24
       LOGIN (command) ............................................   30
       LOGOUT (command) ...........................................   25
       NOOP (command) .............................................   25
:exmp.

:h3.Extensions to the standard
:xmp.
       NAMESPACE (RFC 2342)
:exmp.

:h3.Partly implemented or still under test

:p.(Nothing yet in this list)

:h3.Implemented but not working

:p.(Nothing yet in this list)

:h3.Not implemented

:xmp.
       STARTTTLS (command) .........................   (no index entry)
:exmp.

:h3.Points that still need to be checked

:p.See RFC2683 to see what it has to say.

:p.Check the modified UTF-7 in RFC2152 for the required method of representing
mailbox names that contain non-ASCII characters. I suspect that I can't use
that code "as is" because OS/2 file systems have case-insensitive file names,
and I'm reasonably certain that the modified UTF-7 will require both upper
and lower case alphabetic characters.

:h3.Non-compulsory but desirable improvements

:p.If two or more clients are accessing the same mailbox, updates by one
should be notified to the others by unsolicited messages rather than
waiting for a client poll. From the standard it appears that
unsolicited notification of an EXPUNGE is forbidden, although I still
haven't figured out what to do about the fact that the standard
seems to contradict itself on this point.

:h3.Temporary restrictions

:p.At present the log shows the entire detail of fetched items. I need
this for testing and debugging, but ultimately the actual message
content should, I believe, be suppressed from the log.

:p.Very long log lines are being truncated. I might or might not want
to lift that restriction. (The actual commands and responses are not
being truncated ... actually, I'd better check that point because
in principle really enormous lines are possible.)

:h3.Deliberate violations of the standard.

:p.RFC3501 says "Client and server implementations MUST implement the STARTTLS,
LOGINDISABLED, and AUTH=PLAIN (described in [IMAP-TLS]) capabilities."
I have implemented AUTH=PLAIN but not the other two. LOGINDISABLED is
a bad idea since it would lock out some clients, and users don't have a
wide choice of IMAP clients. STARTTLS is useless unless we have a suitable
security layer, and so far I don't know how to provide that. (I've
started looking at implementing TLS, also known as "secure sockets",
but it looks like a big job that will take a long time.)

:h3.Unclassified so far

:p.(Many (all?) of the features listed below have in fact been implemented, but
I haven't yet completed the walk-through of my
implementation to check it feature by feature against the standard.)

:xmp.
       +FLAGS <flag list> (store command data item) ...............   59
       +FLAGS.SILENT <flag list> (store command data item) ........   59
       -FLAGS <flag list> (store command data item) ...............   59
       -FLAGS.SILENT <flag list> (store command data item) ........   59
       ALERT (response code) ......................................   64
       ALL (fetch item) ...........................................   55
       ALL (search key) ...........................................   50
       ANSWERED (search key) ......................................   50
       APPEND (command) ...........................................   45
       BAD (response) .............................................   66
       BADCHARSET (response code) .................................   64
       BCC <string> (search key) ..................................   51
       BEFORE <date> (search key) .................................   51
       BODY (fetch item) ..........................................   55
       BODY (fetch result) ........................................   73
       BODY <string> (search key) .................................   51



Crispin                     Standards Track                   [Page 103]

RFC 3501                         IMAPv4                       March 2003


       BODY.PEEK[<section>]<<partial>> (fetch item) ...............   57
       BODYSTRUCTURE (fetch item) .................................   57
       BODYSTRUCTURE (fetch result) ...............................   74
       BODY[<section>]<<origin octet>> (fetch result) .............   74
       BODY[<section>]<<partial>> (fetch item) ....................   55
       BYE (response) .............................................   67
       Body Structure (message attribute) .........................   12
       CAPABILITY (response code) .................................   64
       CAPABILITY (response) ......................................   68
       CC <string> (search key) ...................................   51
       CHECK (command) ............................................   47
       CLOSE (command) ............................................   48
       COPY (command) .............................................   59
       CREATE (command) ...........................................   34
       DELETE (command) ...........................................   35
       DELETED (search key) .......................................   51
       DRAFT (search key) .........................................   51
       ENVELOPE (fetch item) ......................................   57
       ENVELOPE (fetch result) ....................................   77
       EXAMINE (command) ..........................................   33
       EXISTS (response) ..........................................   71
       EXPUNGE (command) ..........................................   48
       EXPUNGE (response) .........................................   72
       Envelope Structure (message attribute) .....................   12
       FAST (fetch item) ..........................................   55
       FETCH (command) ............................................   54
       FETCH (response) ...........................................   73
       FLAGGED (search key) .......................................   51
       FLAGS (fetch item) .........................................   57
       FLAGS (fetch result) .......................................   78
       FLAGS (response) ...........................................   71
       FLAGS <flag list> (store command data item) ................   59
       FLAGS.SILENT <flag list> (store command data item) .........   59
       FROM <string> (search key) .................................   51
       FULL (fetch item) ..........................................   55
       Flags (message attribute) ..................................   11
       HEADER (part specifier) ....................................   55
       HEADER <field-name> <string> (search key) ..................   51
       HEADER.FIELDS <header-list> (part specifier) ...............   55
       HEADER.FIELDS.NOT <header-list> (part specifier) ...........   55
       INTERNALDATE (fetch item) ..................................   57
       INTERNALDATE (fetch result) ................................   78
       Internal Date (message attribute) ..........................   12
       KEYWORD <flag> (search key) ................................   51
       Keyword (type of flag) .....................................   11
       LARGER <n> (search key) ....................................   51
       LIST (command) .............................................   40



Crispin                     Standards Track                   [Page 104]

RFC 3501                         IMAPv4                       March 2003


       LIST (response) ............................................   69
       LSUB (command) .............................................   43
       LSUB (response) ............................................   70
       MAY (specification requirement term) .......................    4
       MESSAGES (status item) .....................................   45
       MIME (part specifier) ......................................   56
       MUST (specification requirement term) ......................    4
       MUST NOT (specification requirement term) ..................    4
       Message Sequence Number (message attribute) ................   10
       NEW (search key) ...........................................   51
       NO (response) ..............................................   66
       NOT <search-key> (search key) ..............................   52
       OK (response) ..............................................   65
       OLD (search key) ...........................................   52
       ON <date> (search key) .....................................   52
       OPTIONAL (specification requirement term) ..................    4
       OR <search-key1> <search-key2> (search key) ................   52
       PARSE (response code) ......................................   64
       PERMANENTFLAGS (response code) .............................   64
       PREAUTH (response) .........................................   67
       Permanent Flag (class of flag) .............................   12
       READ-ONLY (response code) ..................................   65
       READ-WRITE (response code) .................................   65
       RECENT (response) ..........................................   72
       RECENT (search key) ........................................   52
       RECENT (status item) .......................................   45
       RENAME (command) ...........................................   37
       REQUIRED (specification requirement term) ..................    4
       RFC822 (fetch item) ........................................   57
       RFC822 (fetch result) ......................................   78
       RFC822.HEADER (fetch item) .................................   57
       RFC822.HEADER (fetch result) ...............................   78
       RFC822.SIZE (fetch item) ...................................   57
       RFC822.SIZE (fetch result) .................................   78
       RFC822.TEXT (fetch item) ...................................   58
       RFC822.TEXT (fetch result) .................................   79
       SEARCH (command) ...........................................   49
       SEARCH (response) ..........................................   71
       SEEN (search key) ..........................................   52
       SELECT (command) ...........................................   31
       SENTBEFORE <date> (search key) .............................   52
       SENTON <date> (search key) .................................   52
       SENTSINCE <date> (search key) ..............................   52
       SHOULD (specification requirement term) ....................    4
       SHOULD NOT (specification requirement term) ................    4



Crispin                     Standards Track                   [Page 105]

RFC 3501                         IMAPv4                       March 2003


       SINCE <date> (search key) ..................................   52
       SMALLER <n> (search key) ...................................   52
       STATUS (command) ...........................................   44
       STATUS (response) ..........................................   70
       STORE (command) ............................................   58
       SUBJECT <string> (search key) ..............................   53
       SUBSCRIBE (command) ........................................   38
       Session Flag (class of flag) ...............................   12
       System Flag (type of flag) .................................   11
       TEXT (part specifier) ......................................   56
       TEXT <string> (search key) .................................   53
       TO <string> (search key) ...................................   53
       TRYCREATE (response code) ..................................   65
       UID (command) ..............................................   60
       UID (fetch item) ...........................................   58
       UID (fetch result) .........................................   79
       UID <sequence set> (search key) ............................   53
       UIDNEXT (response code) ....................................   65
       UIDNEXT (status item) ......................................   45
       UIDVALIDITY (response code) ................................   65
       UIDVALIDITY (status item) ..................................   45
       UNANSWERED (search key) ....................................   53
       UNDELETED (search key) .....................................   53
       UNDRAFT (search key) .......................................   53
       UNFLAGGED (search key) .....................................   53
       UNKEYWORD <flag> (search key) ..............................   53
       UNSEEN (response code) .....................................   65
       UNSEEN (search key) ........................................   53
       UNSEEN (status item) .......................................   45
       UNSUBSCRIBE (command) ......................................   39
       Unique Identifier (UID) (message attribute) ................    8
       X<atom> (command) ..........................................   62
       [RFC-2822] Size (message attribute) ........................   12
       \Answered (system flag) ....................................   11
       \Deleted (system flag) .....................................   11
       \Draft (system flag) .......................................   11
       \Flagged (system flag) .....................................   11
       \Marked (mailbox name attribute) ...........................   69
       \Noinferiors (mailbox name attribute) ......................   69
       \Noselect (mailbox name attribute) .........................   69
       \Recent (system flag) ......................................   11
       \Seen (system flag) ........................................   11
       \Unmarked (mailbox name attribute) .........................   69
:exmp.


:euserdoc.

